import argparse
import os
import sys
import cv2
import tifffile
import cellpose.utils
import numpy as np


if __name__ == '__main__':
    print(sys.argv)
    parser = argparse.ArgumentParser(description="Add image with cell or nucleus outlines")

    parser.add_argument('--cells_path', type=str, help="cells.npy or nucleus.npy path", required=True)
    parser.add_argument('--img_path', type=str, help="HE or FL image ", required=True)
    parser.add_argument('--out_file', type=str, help="out image file path", required=True)
    args = parser.parse_args()

    img_path = args.img_path
    cells_path = args.cells_path
    out_path = args.out_file
    print("img_path:{}\ncells_path:{}\nout_path:{}".format(img_path, cells_path, out_path))

    # img_path = r"D:\code\cell-seg\img\img_dist_fg22\fluorescence.tif"
    img = tifffile.imread(img_path)

    # base_path = r"D:\code\cell-seg\img\img_dist_fg25"
    # save_dir = base_path
    # cells_path = os.path.join(base_path, "cells.npy")

    # cells_path = r"D:\code\cell-seg\img\img_dist_fg22\nucleus.npy"
    cells = np.load(cells_path)
    outline = cellpose.utils.masks_to_outlines(cells)

    img = cv2.resize(img, cells.shape[:2][::-1])
    # 画细胞边界
    if len(img.shape) == 2:
        img[outline] = 200
    else:
        img[outline] = [200, 200, 200]
    tifffile.imwrite(out_path, img, compression="jpeg")
