#!/usr/bin/perl -w
use strict ;

if (@ARGV != 3){
    print "Usage: perl $0 raw_umi_file new_umi_file outfile\n" ;
    exit(1);
}

my ($rawfile, $newfile, $outfile) = @ARGV ;

open (IN, $rawfile) || die "$rawfile, $!\n" ;
my %hbc = ();
while(<IN>){
    chomp ;
    my ($read, $bc, undef, $umi) = split ;
    $hbc{$read} = $bc ;
}
close(IN);

open (IN, $newfile) || die "$newfile, $!\n" ;
open (RAW, ">$outfile.raw") || die "$outfile.raw, $!\n" ;
open (NEW, ">$outfile.new") || die "$outfile.new, $!\n" ;
open (DIF, ">$outfile.diff") || die "$outfile.diff, $!\n" ;
open (ST, ">$outfile.stat") || die "$outfile.stat, $!\n" ;
my %hstat = ();
while(<IN>){
    chomp ;
    my ($read, $bc, undef, undef, $umi) = split ;
    if (!defined $hbc{$read}){
        print NEW "$_\n" ;
        $hstat{'NEW'}++ ;
    }
    elsif ($hbc{$read} eq $bc){
        $hstat{'SAME'}++ ;
        delete $hbc{$read} ;
    }
    elsif ($hbc{$read} ne $bc){
        $hstat{'DIFF'}++ ;
        print DIF "$read\t", $hbc{$read}, "\t$bc\n" ;
        delete $hbc{$read} ;
    }
}
for my $id (keys %hbc){
    print RAW "$id\t", $hbc{$id}, "\n" ;
    $hstat{'RAW'}++ ;
}
for my $type (sort keys %hstat){
    print ST "$type\t", $hstat{$type}, "\n" ;
}
close(IN);
close(RAW);
close(NEW);
close(DIF);
close(ST);

