#!/usr/bin/perl -w
use strict ;

if (@ARGV != 3){
    print "Usage: perl $0 barcode.tsv matrix.tsv outfile\n" ;
    exit(1);
}

my ($bcfile, $mtfile, $outfile) = @ARGV ;

open (IN, $bcfile) || die "$bcfile, $!\n" ;
my $index = 0 ;
my %hbc = ();
while(<IN>){
    chomp ;
    $index++ ;
    my $bc = (split)[0] ;
    $hbc{$index} = $bc ;
}
close(IN);

open (IN, $mtfile) || die "$mtfile, $!\n" ;
<IN> ;
<IN> ;
<IN> ;
my %hmt_bc = ();
while(<IN>){
    chomp ;
    my ($gene_index, $bc_index, $umi_num) = split ;
    my $bc = $hbc{$bc_index} ;
    $hmt_bc{$bc}++ ;
}
close(IN);

my %hstat = ();
for my $bc (keys %hmt_bc){
    my ($bc1, $bc2, $bc3) = split /\-/, $bc ;
    $hstat{bc1}{$bc1}++ ;
    $hstat{bc2}{$bc2}++ ;
    $hstat{bc3}{$bc3}++ ;
}

open (OUT, ">$outfile") || die "$outfile, $!\n" ;
for my $key (sort keys %hstat){
    for my $bc (sort {$hstat{$key}{$a} <=> $hstat{$key}{$b}} keys %{$hstat{$key}}){
        print OUT "$key\t$bc\t", $hstat{$key}{$bc}, "\n" ;
    }
}
close(OUT);

