#!/usr/bin/perl -w
use strict ;

if (@ARGV < 3){
    print "perl $0 fqfile bamfile outfile [readsNum(100000)]\n" ;
    exit(1);
}

my ($fqfile, $bamfile, $outfile, $maxNum) = @ARGV ;

$maxNum ||= 100000 ;

open (IN, "samtools view $bamfile |") || die "$bamfile, $!\n" ;
my %hid = ();
while(<IN>){
    chomp ;
    my ($id) = split ;
    $hid{$id} = 1 ;
}
close(IN);

if ($fqfile =~ /.gz$/){
    open (IN, "gunzip -c $fqfile |") || die "$fqfile, $!\n" ;
}
else{
    open (IN, $fqfile) || die "$fqfile, $!\n" ;
}
open (OUT, ">$outfile") || die "$outfile, $!\n" ;
my $num = 0 ;
while(<IN>){
    my $id = $_ ;
    my $seq = <IN> ;
    my $id2 = <IN> ;
    my $qual = <IN> ;
    chomp($id, $seq, $id2, $qual);
    my $new_id = (split /\s+/, $id)[0] ;
    $new_id =~ s/^\@// ;
    if (!defined $hid{$new_id}){
        print OUT "$id\n$seq\n$id2\n$qual\n" ;
        $num++ ;
        last if ($num >= $maxNum) ;
    }
}
close(IN);
close(OUT);
