library("optparse")
library("plotly")
library("ggplot2")
library("scales")

option_list <- list(
        make_option(c("-i", "--infile"), help="sequencing_saturation.stat"),
        make_option(c("-o", "--outfile"), help="sequencing_saturation.png")
)
opt <- parse_args(OptionParser(option_list=option_list))


#if(!dir.exists(opt$outdir)){dir.create(path=opt$outdir)}

data=read.csv(opt$i,header=TRUE,sep="\t")
names(data)=c("Percent","Uniq","Total","SeqSaturateion")

p<-ggplot(data,aes(x=Total,y=SeqSaturateion))+geom_line(color='#1F77B4')+
    labs(title="Sequencing Saturation", x="Total Reads Count",y="Sequencing Saturation")+coord_cartesian(ylim=c(0,100)) +
    scale_x_continuous(labels = label_number(scale_cut = cut_short_scale())) +
    theme_light() +
    theme(plot.title = element_text(hjust=0.5), plot.margin = margin(t=0.2,l=0.2,b=0.2,r=0.3, unit = "cm"))
htmlwidgets::saveWidget(as_widget(ggplotly(p)), file = opt$o)
#png(opt$o)
#print(p)
#dev.off()



