#!/usr/bin/perl -w
use strict ;

if (@ARGV != 2){
    print "Usage: perl $0 bc_umi_gene.tsv outfile\n" ;
    exit(1);
}

my ($infile, $outfile) = @ARGV ;

open (IN, $infile) || die "$infile, $!\n" ;
my %hstat = ();
while(<IN>){
    chomp ;
    my ($bc, $umi, $gene) = split ;
    $hstat{$bc}{$gene}++ ;
}
close(IN);

my %hnum = ();
for my $bc (keys %hstat){
    my $num = scalar keys %{$hstat{$bc}} ;
    $hnum{$bc} = $num ;
}

open (OUT, ">$outfile") || die "$outfile, $!\n" ;
for my $bc (sort {$hnum{$b}<=>$hnum{$a}} keys %hnum){
    print OUT "$bc\t", $hnum{$bc}, "\n" ;
}
close(OUT) ;

