#!/usr/bin/perl -w
use strict ;

if (@ARGV != 2){
    print "Usage: perl $0 umi_gene.tsv outfile\n" ;
    exit(1);
}

my ($infile, $outfile) = @ARGV ;

open (IN, $infile) || die "$infile, $!\n" ;
my %hbc = ();
while(<IN>){
    chomp ;
    next if (m/^\#|^\s*$/);
    my ($bc, $umi, $gene) = split ;
    $hbc{$bc}++ ;
}
close(IN);

my %hstat = ();
my $num = 0 ;
for my $bc (keys %hbc){
    $num++ ;
    my ($bc1, $bc2, $bc3) = split /\-/, $bc ;
    $hstat{bc1}{$bc1}++ ;
    $hstat{bc2}{$bc2}++ ;
    $hstat{bc3}{$bc3}++ ;
}
print "Total bc num: $num\n" ;

open (OUT, ">$outfile") || die "$outfile, $!\n" ;
for my $key (sort keys %hstat){
    for my $bc (sort {$hstat{$key}{$a} <=> $hstat{$key}{$b}} keys %{$hstat{$key}}){
        print OUT "$key\t$bc\t", $hstat{$key}{$bc}, "\n" ;
    }
}
close(OUT);

